'use strict';

module.exports = {
  extends: 'eslint:recommended',
  parserOptions: {
    ecmaVersion: 8,
    sourceType: 'script',
  },
  env: {
    es6: true,
    node: true,
  },
  rules: {
    'import/no-anonymous-default-export': 0,
    'no-duplicate-imports': 2,
    'complexity': 1,
    'no-var': 2,
    'prefer-const': 2,
    'no-const-assign': 2,
    'no-unused-vars': 1,
    'indent': [1, 2],
    'eqeqeq': 1,
    'quotes': [1, 'single'],
    'comma-dangle': [1, 'always-multiline'],
    'arrow-parens': [1, 'as-needed'],
    'object-shorthand': [1, 'always'],
    'no-extra-bind': 1,
    'no-implied-eval': 2,
    'max-len': [1, 100],
    'space-infix-ops': [1, { 'int32Hint': true }],
    'eol-last': 2,
    'brace-style': 2,
    'curly': [1, 'multi-line'],
    'camelcase': 1,
    'template-curly-spacing': 1,
    'no-eval': 2,
    'max-nested-callbacks': 1,
    'prefer-arrow-callback': 1,
    'no-await-in-loop': 1,
    'no-return-await': 1,
    'no-with': 2,
    'no-useless-return': 1,
    'no-sequences': 2,
    'prefer-rest-params': 2,
    'prefer-spread': 1,
    'no-useless-concat': 1,
    // spacings
    'arrow-spacing': 2,
    'no-spaced-func': 2,
    'space-before-function-paren': [1, {
      'anonymous': 'never',
      'named': 'never',
      'asyncArrow': 'always',
    }],
    'keyword-spacing': 1,
    'comma-spacing': 1,
    'array-bracket-spacing': [1, 'never', { 'singleValue': false }],
    'object-curly-spacing': [1, 'always'],
    'object-curly-newline': [1, { 'multiline': true, 'consistent': true }],
    'object-property-newline': [1, { 'allowAllPropertiesOnSameLine': true }],
    'space-in-parens': [1, 'never'],
    'no-trailing-spaces': 1,
    'no-multi-spaces': 1,
    'no-multiple-empty-lines': [2, { 'max': 2, 'maxEOF': 0, 'maxBOF': 0 }],
  },
};
